package at.asit.project.timing;

import androidx.annotation.NonNull;

import java.lang.reflect.Method;
import java.util.Arrays;
import java.util.concurrent.CountDownLatch;

public class CallbackListener implements java.lang.reflect.InvocationHandler {

  public static CountDownLatch countDownLatch;
  public static long endTime;

  public CallbackListener() {
  }

  @Override
  public Object invoke(Object proxy, @NonNull Method method, Object[] args) throws Throwable {
    endTime = System.nanoTime();
    System.out.println("[CALLBACK] INVOKED " + method.getName() + " with args " + Arrays.toString(args));
    if (countDownLatch != null) {
      countDownLatch.countDown();
    }
    return null;
  }

  @NonNull
  @Override
  public String toString() {
    return "Custom CallbackListener{}";
  }
}
